/*
	ver0.1	(10.05.17) : first release
	ver0.2	(10.05.19) : zoom ratio, font size, sync button, nowrap
	ver0.3	(10.05.21) : hide recent search, PDF, removeEventListener
	ver0.31 (10.06.12) : change logo style
	ver0.4	(10.11.10) : google snapshot
	ver0.5	(11.02.27) : no DOMContentLoaded, disable onmousedown
	ver0.51 (11.10.01)
	ver0.52 (11.11.18)
	ver0.53 (12.7.4)   : navigator.preference is no longer supported in Firefox 4.
*/

var gonside = {
	LOG: function(text) {
		var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
   		consoleService.logStringMessage(String(text));
	},

	getCookie : function(name, defaultValue) {
		name += '=';
		var cookie = document.cookie + ';';
		var n = cookie.indexOf(name);
		if (n >= 0) {
			n += name.length;
			var n1 = cookie.indexOf(';', n);
			if (n < n1) {
				return unescape(cookie.substring(n, n1));
			}
		}
		return defaultValue;
	},

	setCookie: function(name, value, days) { // TODO:
		if (!days == 0) days = 30;
		var expires = new Date();
		expires.setTime(expires.getTime() + (days * 1000 * 60 * 60 * 24));
		document.cookie = name + '=' + escape(value) + '; expires=' + expires.toGMTString() + '; path=/';
	},
	
	loadURL: function() {
		return this.getCookie("gonsideURL", "");
	},

	saveURL: function(url) {
		this.setCookie("gonsideURL", url, 30);
	},

	css_rules: [
		"#gbar {display:none;}",
		".lst {width:240px;}",
		"#plw {width:300px;}"
	],

	css_rules_r: [
		// "div.tphdr {display:none;}",
		"#gbar {display:none;}",
		"#cnt {min-width:200px;}",
		// "div.rshdr {min-width:200px;}",
		"#gbq1 {display:none;}", // ## 120704
		"#gbq2 {position:relative;left:-120px;}",
		"#gbqf {min-width:300px;}",
		"#gbqfbw {margin:0px 4px;}",
		"div#appbar {display:none;}",
		"div.lsd {display:none;}",
		"div.tsf-p {margin-left:8px;margin-right:8px;padding-left:8px;}",
		"#subform_ctrl {display:none;}",
		"#center_col {margin-left:0;margin-right:0;min-width:562px;}",
		"#trev {display:none;}",
		"#leftnav {display:none;width:0;padding:0;}",
		"#rhs {visibility:hidden;}",
		"#tads {display:none;}",
		"#tadsb {display:none;}",
		"li.g {margin-bottom:0px;white-space:nowrap;line-height:1.4;}", // ## 120704
		"div.s {display:none;}",
		"table.ts {display:none;}",
		"li#blogbox {display:none;}",
		"#brs {display:none;}",
		"li#imagebox {display:none;}",
		"#foot {margin-left:0;}",
		"#navcnt {width:300px;}",
		"#fll {display:none;}",
		"#gonside_sync {margin-left:4px;}",
		"div#iur {display:none;}",
		"table.nrgt {display:none;}", // ## 111118
		"div.nrtd {display:none;}",
		"div#results {display:none;}",
	],

	getStyleSheet: function(doc) {
		var sheet = doc.styleSheets[0];
		if (!sheet)
			gonside.LOG("style sheet not ready!");
		return sheet;
	},

	addCSSRule: function(doc, rule) {
		var sheet = this.getStyleSheet(doc);
		if (!sheet) return;
		sheet.insertRule(rule, sheet.cssRules.length);
	},

	addCSSRules: function(doc, rules) {
		var sheet = this.getStyleSheet(doc);
		if (!sheet) return;
		for (var i = 0; i < rules.length; i++) {
			sheet.insertRule(rules[i], sheet.cssRules.length);
		}
	},

	getInputDiv: function(doc) {
		var div = doc.getElementById("tsf");
		if (div) {
			div = div.firstChild;
			while (div && (div.nodeType != 1 || div.tagName.toLowerCase() != "div" || div.id == "tophf")) { div = div.nextSibling; }
		}
		return div;
	},

	search: function(doc) {
		this.addCSSRules(doc, this.css_rules);
		this.setFontSize(doc, false);
	},

	result: function(doc) {
		this.addCSSRules(doc, this.css_rules_r);
		this.setFontSize(doc, true);
		var	div = doc.getElementById("logocont"); // ## 111118
		if (div) {
			div.style.cssFloat = null;
			div.style.position = null; //  ## 111201
		} else {
			div = doc.getElementById("logo");
			if (div) {
				div = div.parentNode.parentNode;
				// div.style.position = "relative";   ## 100612
				div.style.cssFloat = null;
			}
		}
/*		var div = gonside.getInputDiv(doc);
		if (div) {
			div = div.firstChild;
			if (div) {
				div.style.position = null;
				div.style.cssFloat = null;
				div = div.nextSibling;
				div.style.marginLeft = "16px";
				div.style.marginRight = "16px";
			}
		}*/
		if (!doc.getElementById("ires")) return;

		var center_col = doc.getElementById("center_col"); // ## 111001
		center_col.style.marginLeft = "0";
		var foot = doc.getElementById("foot"); // ## 111001
		foot.style.marginLeft = "0";

		var sb = doc.getElementById("sb"); // scrollbar
		if (sb) {
			sb.style.display = "none";
			sb.nextSibling.style.display = "none";
		}

		var btm = doc.getElementById("sftr"); // bottom search box
		if (btm) {
			// btm.parentNode.style.display = "none";
			btm.style.display = "none";
		}

		var nav = doc.getElementById("navcnt");
		if (nav) {
//			var div = nav.nextSibling.nextSibling;
//			div.style.display = "none";
//			div.nextSibling.style.display = "none";
		
			// var tr = nav.firstChild.firstChild.firstChild;
			var tr = nav.firstElementChild.firstElementChild.firstElementChild;
			for (var i = 0; i < tr.cells.length; i++) {
				if (i > 10 && i < tr.cells.length - 1) { // max 10
					tr.cells[i].style.display = "none";
				}
			}
/*			var prev = tr.firstChild.firstChild.lastChild;
			if (prev) {
				prev.style.marginRight = "0px";
			}
			var next = tr.lastChild.firstChild.lastChild;
			if (next) {
				next.style.marginLeft = "8px";
			}*/
			var prev = doc.getElementById("pnprev");
			if (prev) {
				prev = prev.firstElementChild.nextElementSibling;
				if (prev) {
					prev.style.marginRight = "0px";
				}
			}
			var next = doc.getElementById("pnnext");
			if (next) {
				next = next.firstElementChild.nextElementSibling;
				if (next) {
					next.style.marginLeft = "8px";
				}
			}
		}
		doc.defaultView.addEventListener("mousedown", gonside.onMouseDown, true);
		doc.defaultView.addEventListener("click", gonside.onClick, false);
		doc.defaultView.addEventListener("unload", gonside.onUnload, false);

//		window.setTimeout(function() {
			gonside.numbering(doc);
			gonside.addSyncButton(doc);
//		}, 100);
	},

	onUnload: function(event) {
		var doc = event.originalTarget;
		doc.defaultView.removeEventListener("mousedown", gonside.onMouseDown, true);
		doc.defaultView.removeEventListener("click", gonside.onClick, false);
		doc.defaultView.removeEventListener("unload", gonside.onUnload, false);
	},	
	
	numbering: function(doc) {
		var s = doc.location.href;
		s = s.match(/\&start\=\d+/i);
		var start = s ? Number(String(s).substr(7)) : 0;
		var ires = doc.getElementById("ires");
		if (!ires) return;
		// var li = ires.firstChild.firstChild;
		var li = ires.firstElementChild.firstElementChild;
		var i = 1;
		while (li) {
			if (li.nodeType == 1 && li.tagName.toLowerCase() == "li") {
				li.style.marginBottom = "0";
				var h3 = li.firstChild;
				if (h3) {
					if (h3.nodeType == 1 && h3.tagName.toLowerCase() != "h3") {
						h3 = h3.firstChild;
					}
					if (h3.nodeType == 1 && h3.tagName.toLowerCase() == "h3") {
						var html = h3.innerHTML;
						if (!html.match(/^\d+\.\s*</)) {
							h3.innerHTML = String(start + i++) + '. ' + html;
						}
					}
				}
			}
			li = li.nextSibling;
		}
	},

	toolTipText: function(html) {
		var n = html.indexOf('<br>');
		if (n != -1) html = html.substr(0, n);
		return html.replace(/<\/?[a-z]+>/ig, "");
	},

	addSyncButton: function(doc) {
		var e = doc.createElement("a");
		e.id = "gonside_sync";
		e.href = doc.location.href;
		e.innerHTML = ">>";
/*		var logo = doc.getElementById("logo");
		if (!logo) {
			logo = gonside.getInputDiv(doc);
			if (!logo) return;
		}
		logo.parentNode.insertBefore(e, null);
*/
		var div = doc.getElementById("gbqfbw");
		div.parentNode.insertBefore(e, div);
	},

	setZoom: function() {
		// this.zoom(navigator.preference("extensions.googleonsidebar.zoomratio"));
	},

	resetZoom: function() {
		// this.zoom(100);
	},

	zoom: function(value) {
		var viewer = document.getElementById('sidebar').markupDocumentViewer;
		if (Math.round(viewer.fullZoom * 100) != value)
			viewer.fullZoom = value / 100;
	},

	setFontSize: function(doc, result) {
/*		var size = navigator.preference("extensions.googleonsidebar.searchfont");
		this.addCSSRule(doc, "input.lst {font-size:" + size + "px !important" + ";height:" + (size + 6) +"px !important;}");
		this.addCSSRule(doc, "div.ds {height:" + (size + 13) +"px !important;}");
		this.addCSSRule(doc, "table.gac_m {font-size:" + (size - 1) + "px;}");
		if (result) {
			this.addCSSRule(doc, "div.lsbb {height:" + (size + 11) +"px;}");
			this.addCSSRule(doc, "input.lsb {height:" + (size + 11) +"px;}");
		}*/
	},

	onMouseDown: function(event) {
		var target = event.target; // ## 111118
		if (target && target.tagName) {
			var tagName = target.tagName.toLowerCase();
			if (tagName == "a" || tagName == "em") {
				event.stopPropagation();
			}
		}
		return;
	},

	onClick: function(event) {
		var target = event.target;
		for (;;) {
			if (!target || !target.tagName) return;
			var tagName = target.tagName.toLowerCase();
			if (tagName == "html" || tagName == "div" ) return;
			if (tagName == "a") break;
			target = target.parentNode;
		}
		if (target.className != "l") {
			if (target.href.match(/\.google\.[a-z\.]+\/search.*\&start\=/i) || target.className == "spell" || target.id == "logo") { // pager link
				if (target.id == "logo") {
					gonside.saveURL("");
				}
				target.ownerDocument.defaultView.location.href = target.href;
				event.preventDefault();
			}
		}
	},

	onLoad2: function(event) {
		alert("onLoad2");
	},

	onLoad: function(event) {
		var doc = event.originalTarget;
		if (doc.defaultView.name == 'web-panels-browser') {
			var url = doc.location.href;
			gonside.doResult(doc);
			if (url.match(/\.google\.[a-z\.]+\/(webhp|$)/)) {
				doc.defaultView.addEventListener("keydown", gonside.keyDown, false);
				gonside.setZoom();
				var searchUrl = gonside.loadURL();
				if (searchUrl) {
					doc.location.href = searchUrl;
					window.setTimeout(function() {
						gonside.doResult(doc);
					}, 500);
					return;
				}
				gonside.search(doc);
			} else {
				gonside.resetZoom();
			}
		}
	},
	doResult: function(doc) {
		var url = doc.location.href;
		if (url.match(/\.google\..+[?&]q=/)) {
			gonside.setZoom();
			gonside.result(doc);
			gonside.saveURL(url);
		}
	},

	keyDown: function(event) {
		if (event.keyCode == 13) { // Enter
			window.setTimeout(function() {
				var doc = event.originalTarget.ownerDocument;
				gonside.doResult(doc);
			}, 500);
		}
	},

	observer: {
		observe: function(aSubject, aTopic, aData) {
			if(aTopic == "gonside-toggleSidebar") {
				if (aData == "viewWebPanelsSidebar") {
				} else if (aData == "viewBookmarksSidebar") {
					setTimeout(function() { gonside.resetZoom(); }, 1);
				}
			}
		}
	},

	_observerService: null,

	getObserverService : function() {
		if (this._observerService == null)
			this._observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		return this._observerService;
	},

	init: function(event) {
		if(typeof toggleSidebar != "undefined") {
			var toggleSidebarOrg = toggleSidebar;
			toggleSidebar = function(commandID, forceOpen) {
				gonside.getObserverService().notifyObservers(null, "gonside-toggleSidebar", commandID);
				return toggleSidebarOrg(commandID, forceOpen);
			};
			gonside.getObserverService().addObserver(gonside.observer, "gonside-toggleSidebar", false);
		}
	},
	
	exit: function(event) {
		gonside.getObserverService().removeObserver(gonside.observer, "gonside-toggleSidebar", false);

		window.removeEventListener("load", gonside.init, false);
		window.removeEventListener("unload", gonside.exit, false);
		document.removeEventListener("DOMContentLoaded", gonside.onLoad, true);
	}
};

window.addEventListener("load", gonside.init, false);
window.addEventListener("unload", gonside.exit, false);
document.addEventListener("DOMContentLoaded", gonside.onLoad, true); // ??
